<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_matching_rules".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeMatchingRules".
 *
 * Columns in table "provider_practice_matching_rules" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property integer $enabled
 * @property string $match_entity
 * @property integer $priority_order
 * @property string $rule_name
 * @property string $rule_details
 * @property string $key_first_name
 * @property string $key_middle_name
 * @property string $key_last_name
 * @property string $key_credential
 * @property string $key_gender
 * @property string $key_specialty
 * @property string $key_provider_url
 * @property string $key_practice_name
 * @property string $key_practice_address
 * @property string $key_practice_address_2
 * @property string $key_practice_zipcode
 * @property string $key_practice_city
 * @property string $key_practice_state
 * @property string $key_practice_phone_number
 * @property string $key_practice_latitude
 * @property string $key_practice_longitude
 * @property string $match_query
 *
 */
abstract class BaseProviderPracticeMatchingRules extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_matching_rules';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeMatchingRules|ProviderPracticeMatchingRules', $n);
    }

    public static function representingColumn()
    {
        return 'match_entity';
    }

    public function rules()
    {
        return array(
            array(
                'match_entity, priority_order, rule_name, key_first_name, key_middle_name, key_last_name, 
                    key_credential, key_gender, key_specialty, key_provider_url, key_practice_name, 
                    key_practice_address_2, key_practice_zipcode, key_practice_city, key_practice_state, 
                    key_practice_phone_number, key_practice_latitude, key_practice_longitude, match_query', 
                'required'
            ),
            array('enabled, priority_order', 'numerical', 'integerOnly' => true),
            array('match_entity', 'length', 'max' => 8),
            array('rule_name', 'length', 'max' => 230),
            array(
                'key_first_name, key_middle_name, key_last_name, key_credential, key_gender, key_specialty, 
                    key_provider_url, key_practice_name, key_practice_address, key_practice_address_2, 
                    key_practice_zipcode, key_practice_city, key_practice_state, key_practice_phone_number, 
                    key_practice_latitude, key_practice_longitude', 
                'length', 
                'max' => 50
            ),
            array('rule_details', 'safe'),
            array('enabled, rule_details, key_practice_address', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, enabled, match_entity, priority_order, rule_name, rule_details, key_first_name, key_middle_name, 
                    key_last_name, key_credential, key_gender, key_specialty, key_provider_url, key_practice_name, 
                        key_practice_address, key_practice_address_2, key_practice_zipcode, key_practice_city, 
                        key_practice_state, key_practice_phone_number, key_practice_latitude, key_practice_longitude, 
                        match_query', 
                    'safe', 
                    'on' => 'search'
                ),
        );
    }

    public function relations()
    {
        return array();
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'enabled' => Yii::t('app', 'Enabled'),
            'match_entity' => Yii::t('app', 'Match Entity'),
            'priority_order' => Yii::t('app', 'Priority Order'),
            'rule_name' => Yii::t('app', 'Rule Name'),
            'rule_details' => Yii::t('app', 'Rule Details'),
            'key_first_name' => Yii::t('app', 'Key First Name'),
            'key_middle_name' => Yii::t('app', 'Key Middle Name'),
            'key_last_name' => Yii::t('app', 'Key Last Name'),
            'key_credential' => Yii::t('app', 'Key Credential'),
            'key_gender' => Yii::t('app', 'Key Gender'),
            'key_specialty' => Yii::t('app', 'Key Specialty'),
            'key_provider_url' => Yii::t('app', 'Key Provider Url'),
            'key_practice_name' => Yii::t('app', 'Key Practice Name'),
            'key_practice_address' => Yii::t('app', 'Key Practice Address'),
            'key_practice_address_2' => Yii::t('app', 'Key Practice Address 2'),
            'key_practice_zipcode' => Yii::t('app', 'Key Practice Zipcode'),
            'key_practice_city' => Yii::t('app', 'Key Practice City'),
            'key_practice_state' => Yii::t('app', 'Key Practice State'),
            'key_practice_phone_number' => Yii::t('app', 'Key Practice Phone Number'),
            'key_practice_latitude' => Yii::t('app', 'Key Practice Latitude'),
            'key_practice_longitude' => Yii::t('app', 'Key Practice Longitude'),
            'match_query' => Yii::t('app', 'Match Query'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('match_entity', $this->match_entity, true);
        $criteria->compare('priority_order', $this->priority_order);
        $criteria->compare('rule_name', $this->rule_name, true);
        $criteria->compare('rule_details', $this->rule_details, true);
        $criteria->compare('key_first_name', $this->key_first_name, true);
        $criteria->compare('key_middle_name', $this->key_middle_name, true);
        $criteria->compare('key_last_name', $this->key_last_name, true);
        $criteria->compare('key_credential', $this->key_credential, true);
        $criteria->compare('key_gender', $this->key_gender, true);
        $criteria->compare('key_specialty', $this->key_specialty, true);
        $criteria->compare('key_provider_url', $this->key_provider_url, true);
        $criteria->compare('key_practice_name', $this->key_practice_name, true);
        $criteria->compare('key_practice_address', $this->key_practice_address, true);
        $criteria->compare('key_practice_address_2', $this->key_practice_address_2, true);
        $criteria->compare('key_practice_zipcode', $this->key_practice_zipcode, true);
        $criteria->compare('key_practice_city', $this->key_practice_city, true);
        $criteria->compare('key_practice_state', $this->key_practice_state, true);
        $criteria->compare('key_practice_phone_number', $this->key_practice_phone_number, true);
        $criteria->compare('key_practice_latitude', $this->key_practice_latitude, true);
        $criteria->compare('key_practice_longitude', $this->key_practice_longitude, true);
        $criteria->compare('match_query', $this->match_query, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
